/**
 * This file automatically has been generated by ULS and
 *  contains an implementation of lexical analyzer
 *  for parsing the programming language 'csharp'.
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following
 * conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 */
#pragma once

#include <uls/UlsLex.h>
#include <string>

namespace ULS {
	namespace Collection {
		class CsharpLex : public uls::crux::UlsLex {
		  public:
			static const int              ERR = -8;
			static const int             NONE = -7;
			static const int             LINK = -6;
			static const int             TMPL = -5;
			static const int          LINENUM = -4;
			static const int           NUMBER = -3;
			static const int               ID = -2;
			static const int              EOF = -1;

			static const int              EOI = 0;

			static const int             AUTO = 4;
			static const int            BREAK = 5;
			static const int             CASE = 6;
			static const int             CHAR = 7;
			static const int            CONST = 8;
			static const int         CONTINUE = 9;

			static const int          DEFAULT = 10;
			static const int               DO = 11;
			static const int           DOUBLE = 12;
			static const int             ELSE = 13;
			static const int             ENUM = 14;
			static const int           EXTERN = 15;
			static const int            FLOAT = 16;
			static const int              FOR = 17;
			static const int             GOTO = 18;
			static const int               IF = 19;

			static const int              INT = 20;
			static const int             LONG = 21;
			static const int         REGISTER = 22;
			static const int           RETURN = 23;
			static const int            SHORT = 24;
			static const int           SIGNED = 25;
			static const int           SIZEOF = 26;
			static const int           STATIC = 27;
			static const int           STRUCT = 28;
			static const int           SWITCH = 29;

			static const int          TYPEDEF = 30;
			static const int            UNION = 31;
			static const int         UNSIGNED = 32;
			static const int           DQUOTE = 34;
			static const int           SQUOTE = 39;
			static const int             VOID = 48;
			static const int         VOLATILE = 49;

			static const int            WHILE = 50;
			static const int           VQUOTE = 64;
			static const int          POINTER = 64;
			static const int             INCR = 65;
			static const int             DECR = 66;
			static const int              LEQ = 67;
			static const int              GEQ = 68;
			static const int              EQL = 69;

			static const int              NEQ = 70;
			static const int              AND = 71;
			static const int               OR = 72;
			static const int         ADD_ASGN = 73;
			static const int         SUB_ASGN = 74;
			static const int         MUL_ASGN = 75;
			static const int         DIV_ASGN = 76;
			static const int         MOD_ASGN = 77;
			static const int      BITAND_ASGN = 78;
			static const int       BITOR_ASGN = 79;

			static const int      BITXOR_ASGN = 80;
			static const int      LSHIFT_ASGN = 81;
			static const int      RSHIFT_ASGN = 82;
			static const int         ABSTRACT = 128;
			static const int               AS = 129;

			static const int             BASE = 130;
			static const int             BOOL = 131;
			static const int             BYTE = 132;
			static const int            CATCH = 133;
			static const int          CHECKED = 134;
			static const int            CLASS = 135;
			static const int          DECIMAL = 136;
			static const int         DELEGATE = 137;
			static const int            EVENT = 138;
			static const int         EXPLICIT = 139;

			static const int            FALSE = 140;
			static const int          FINALLY = 141;
			static const int            FIXED = 142;
			static const int          FOREACH = 143;
			static const int         IMPLICIT = 144;
			static const int               IN = 145;
			static const int        INTERFACE = 146;
			static const int         INTERNAL = 147;
			static const int               IS = 148;
			static const int             LOCK = 149;

			static const int        NAMESPACE = 150;
			static const int              NEW = 151;
			static const int             NULL = 152;
			static const int           OBJECT = 153;
			static const int         OPERATOR = 154;
			static const int              OUT = 155;
			static const int         OVERRIDE = 156;
			static const int           PARAMS = 157;
			static const int          PRIVATE = 158;
			static const int        PROTECTED = 159;

			static const int           PUBLIC = 160;
			static const int         READONLY = 161;
			static const int              REF = 162;
			static const int            SBYTE = 163;
			static const int           SEALED = 164;
			static const int       STACKALLOC = 165;
			static const int           STRING = 166;
			static const int             THIS = 167;
			static const int            THROW = 168;
			static const int             TRUE = 169;

			static const int              TRY = 170;
			static const int           TYPEOF = 171;
			static const int             UINT = 172;
			static const int            ULONG = 173;
			static const int        UNCHECKED = 174;
			static const int           UNSAFE = 175;
			static const int           USHORT = 176;
			static const int            USING = 177;
			static const int          VIRTUAL = 178;

			CsharpLex(std::tstring &ulc_fpath)
				 : uls::crux::UlsLex(ulc_fpath) {}
		};
	}
}
