/**
 * This file automatically has been generated by ULS and
 *  contains an implementation of lexical analyzer
 *  for parsing the programming language 'javascript'.
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following
 * conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 */
#pragma once

#include <uls/UlsLex.h>
#include <string>

namespace ULS {
	namespace Collection {
		class JavaScriptLex : public uls::crux::UlsLex {
		  public:
			static const int             NONE = -5;
			static const int             TMPL = -4;
			static const int          LINENUM = -3;
			static const int              ERR = -2;
			static const int          ENDFILE = -1;

			static const int              EOI = 0;
			static const int               ID = 1;
			static const int              TAB = 9;
			static const int           DQUOTE = 34;

			static const int           SQUOTE = 39;
			static const int            BREAK = 256;
			static const int         CONTINUE = 257;
			static const int               DO = 258;
			static const int              FOR = 259;

			static const int           IMPORT = 260;
			static const int              NEW = 261;
			static const int             THIS = 262;
			static const int             VOID = 263;
			static const int             CASE = 264;
			static const int          DEFAULT = 265;
			static const int             ELSE = 266;
			static const int         FUNCTION = 267;
			static const int               IN = 268;
			static const int           RETURN = 269;

			static const int           TYPEOF = 270;
			static const int            WHILE = 271;
			static const int          COMMENT = 272;
			static const int           DELETE = 273;
			static const int           EXPORT = 274;
			static const int               IF = 275;
			static const int            LABEL = 276;
			static const int           SWITCH = 277;
			static const int              VAR = 278;
			static const int             WITH = 279;

			static const int         ABSTRACT = 280;
			static const int       IMPLEMENTS = 281;
			static const int        PROTECTED = 282;
			static const int          BOOLEAN = 283;
			static const int       INSTANCEOF = 284;
			static const int           PUBLIC = 285;
			static const int             BYTE = 286;
			static const int              INT = 287;
			static const int            SHORT = 288;
			static const int             CHAR = 289;

			static const int        INTERFACE = 290;
			static const int           STATIC = 291;
			static const int           DOUBLE = 292;
			static const int             LONG = 293;
			static const int     SYNCHRONIZED = 294;
			static const int            FALSE = 295;
			static const int           NATIVE = 296;
			static const int           THROWS = 297;
			static const int            FINAL = 298;
			static const int             NULL = 299;

			static const int        TRANSIENT = 300;
			static const int            FLOAT = 301;
			static const int          PACKAGE = 302;
			static const int             TRUE = 303;
			static const int             GOTO = 304;
			static const int          PRIVATE = 305;
			static const int            CATCH = 306;
			static const int             ENUM = 307;
			static const int            THROW = 308;
			static const int            CLASS = 309;

			static const int          EXTENDS = 310;
			static const int              TRY = 311;
			static const int            CONST = 312;
			static const int          FINALLY = 313;
			static const int         DEBUGGER = 314;
			static const int            SUPER = 315;
			static const int            ALERT = 316;
			static const int             EVAL = 317;
			static const int             LINK = 318;
			static const int      OUTERHEIGHT = 319;

			static const int         SCROLLTO = 320;
			static const int           ANCHOR = 321;
			static const int       FILEUPLOAD = 322;
			static const int         LOCATION = 323;
			static const int       OUTERWIDTH = 324;
			static const int           SELECT = 325;
			static const int             AREA = 326;
			static const int             FIND = 327;
			static const int         PACKAGES = 328;
			static const int             SELF = 329;

			static const int        ARGUMENTS = 330;
			static const int            FOCUS = 331;
			static const int      LOCATIONBAR = 332;
			static const int      PAGEXOFFSET = 333;
			static const int      SETINTERVAL = 334;
			static const int            ARRAY = 335;
			static const int             FORM = 336;
			static const int             MATH = 337;
			static const int      PAGEYOFFSET = 338;
			static const int       SETTIMEOUT = 339;

			static const int           ASSIGN = 340;
			static const int            FRAME = 341;
			static const int          MENUBAR = 342;
			static const int           PARENT = 343;
			static const int           STATUS = 344;
			static const int             BLUR = 345;
			static const int           FRAMES = 346;
			static const int         MIMETYPE = 347;
			static const int       PARSEFLOAT = 348;
			static const int        STATUSBAR = 349;

			static const int           MOVEBY = 350;
			static const int         PARSEINT = 351;
			static const int             STOP = 352;
			static const int           BUTTON = 353;
			static const int         GETCLASS = 354;
			static const int           MOVETO = 355;
			static const int         PASSWORD = 356;
			static const int           STRING = 357;
			static const int           CALLEE = 358;
			static const int           HIDDEN = 359;

			static const int             NAME = 360;
			static const int      PERSONALBAR = 361;
			static const int           SUBMIT = 362;
			static const int           CALLER = 363;
			static const int          HISTORY = 364;
			static const int              NAN = 365;
			static const int           PLUGIN = 366;
			static const int              SUN = 367;
			static const int    CAPTUREEVENTS = 368;
			static const int         NAVIGATE = 369;

			static const int            PRINT = 370;
			static const int            TAINT = 371;
			static const int         CHECKBOX = 372;
			static const int             HOME = 373;
			static const int        NAVIGATOR = 374;
			static const int           PROMPT = 375;
			static const int             TEXT = 376;
			static const int    CLEARINTERVAL = 377;
			static const int            IMAGE = 378;
			static const int        PROTOTYPE = 379;

			static const int         TEXTAREA = 380;
			static const int     CLEARTIMEOUT = 381;
			static const int         INFINITY = 382;
			static const int         NETSCAPE = 383;
			static const int            RADIO = 384;
			static const int          TOOLBAR = 385;
			static const int            CLOSE = 386;
			static const int      INNERHEIGHT = 387;
			static const int           NUMBER = 388;
			static const int              REF = 389;

			static const int              TOP = 390;
			static const int           CLOSED = 391;
			static const int       INNERWIDTH = 392;
			static const int           OBJECT = 393;
			static const int           REGEXP = 394;
			static const int         TOSTRING = 395;
			static const int          CONFIRM = 396;
			static const int         ISFINITE = 397;
			static const int           ONBLUR = 398;
			static const int    RELEASEEVENTS = 399;

			static const int         UNESCAPE = 400;
			static const int      CONSTRUCTOR = 401;
			static const int            ISNAN = 402;
			static const int          ONERROR = 403;
			static const int            RESET = 404;
			static const int          UNTAINT = 405;
			static const int             DATE = 406;
			static const int             JAVA = 407;
			static const int          ONFOCUS = 408;
			static const int         RESIZEBY = 409;

			static const int          UNWATCH = 410;
			static const int    DEFAULTSTATUS = 411;
			static const int        JAVAARRAY = 412;
			static const int           ONLOAD = 413;
			static const int         RESIZETO = 414;
			static const int          VALUEOF = 415;
			static const int         DOCUMENT = 416;
			static const int        JAVACLASS = 417;
			static const int         ONUNLOAD = 418;
			static const int       ROUTEEVENT = 419;

			static const int            WATCH = 420;
			static const int       JAVAOBJECT = 421;
			static const int             OPEN = 422;
			static const int           SCROLL = 423;
			static const int           WINDOW = 424;
			static const int          ELEMENT = 425;
			static const int      JAVAPACKAGE = 426;
			static const int           OPENER = 427;
			static const int       SCROLLBARS = 428;
			static const int           ESCAPE = 429;

			static const int           LENGTH = 430;
			static const int           OPTION = 431;
			static const int         SCROLLBY = 432;

			JavaScriptLex(std::tstring &ulc_fpath)
				 : uls::crux::UlsLex(ulc_fpath) {}
		};
	}
}
