/**
 * This file automatically has been generated by ULS and
 *  contains an implementation of lexical analyzer
 *  for parsing the programming language 'visual_basic'.
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following
 * conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 */
#pragma once

#include <uls/UlsLex.h>
#include <string>

namespace ULS {
	namespace Collection {
		class VisualBasicLex : public uls::crux::UlsLex {
		  public:
			static const int              ERR = -8;
			static const int             NONE = -7;
			static const int             LINK = -6;
			static const int             TMPL = -5;
			static const int          LINENUM = -4;
			static const int           NUMBER = -3;
			static const int               ID = -2;
			static const int              EOF = -1;

			static const int              EOI = 0;

			static const int      RUNE_LITSTR = 128;
			static const int    CONDDIR_CONST = 129;

			static const int       CONDDIR_IF = 130;
			static const int     CONDDIR_ELSE = 131;
			static const int   CONDDIR_ELSEIF = 132;
			static const int      CONDDIR_END = 133;
			static const int             ASGN = 134;
			static const int         BANDASGN = 135;
			static const int          MULASGN = 136;
			static const int          DIVASGN = 137;
			static const int       RSLASHASGN = 138;
			static const int         BXORASGN = 139;

			static const int          ADDASGN = 140;
			static const int          SUBASGN = 141;
			static const int         BLSHASGN = 142;
			static const int         BRSHASGN = 143;
			static const int       ADDHANDLER = 144;
			static const int        ADDRESSOF = 145;
			static const int            ALIAS = 146;
			static const int              AND = 147;
			static const int          ANDALSO = 148;
			static const int               AS = 149;

			static const int          BOOLEAN = 150;
			static const int            BYREF = 151;
			static const int             BYTE = 152;
			static const int            BYVAL = 153;
			static const int             CALL = 154;
			static const int             CASE = 155;
			static const int            CATCH = 156;
			static const int            CBOOL = 157;
			static const int            CBYTE = 158;
			static const int            CCHAR = 159;

			static const int            CDATE = 160;
			static const int             CDEC = 161;
			static const int             CDBL = 162;
			static const int             CHAR = 163;
			static const int             CINT = 164;
			static const int            CLASS = 165;
			static const int             CLNG = 166;
			static const int             COBJ = 167;
			static const int            CONST = 168;
			static const int         CONTINUE = 169;

			static const int           CSBYTE = 170;
			static const int           CSHORT = 171;
			static const int             CSNG = 172;
			static const int             CSTR = 173;
			static const int            CTYPE = 174;
			static const int            CUINT = 175;
			static const int            CULNG = 176;
			static const int          CUSHORT = 177;
			static const int             DATE = 178;
			static const int          DECIMAL = 179;

			static const int          DECLARE = 180;
			static const int          DEFAULT = 181;
			static const int         DELEGATE = 182;
			static const int              DIM = 183;
			static const int       DIRECTCAST = 184;
			static const int               DO = 185;
			static const int           DOUBLE = 186;
			static const int             EACH = 187;
			static const int             ELSE = 188;
			static const int           ELSEIF = 189;

			static const int              END = 190;
			static const int            ENDIF = 191;
			static const int             ENUM = 192;
			static const int            ERASE = 193;
			static const int            ERROR = 194;
			static const int            EVENT = 195;
			static const int             EXIT = 196;
			static const int            FALSE = 197;
			static const int          FINALLY = 198;
			static const int              FOR = 199;

			static const int           FRIEND = 200;
			static const int         FUNCTION = 201;
			static const int              GET = 202;
			static const int          GETTYPE = 203;
			static const int  GETXMLNAMESPACE = 204;
			static const int           GLOBAL = 205;
			static const int            GOSUB = 206;
			static const int             GOTO = 207;
			static const int          HANDLES = 208;
			static const int               IF = 209;

			static const int       IMPLEMENTS = 210;
			static const int          IMPORTS = 211;
			static const int               IN = 212;
			static const int         INHERITS = 213;
			static const int          INTEGER = 214;
			static const int        INTERFACE = 215;
			static const int               IS = 216;
			static const int            ISNOT = 217;
			static const int              LET = 218;
			static const int              LIB = 219;

			static const int             LIKE = 220;
			static const int             LONG = 221;
			static const int             LOOP = 222;
			static const int               ME = 223;
			static const int              MOD = 224;
			static const int           MODULE = 225;
			static const int      MUSTINHERIT = 226;
			static const int     MUSTOVERRIDE = 227;
			static const int           MYBASE = 228;
			static const int          MYCLASS = 229;

			static const int        NAMESPACE = 230;
			static const int        NARROWING = 231;
			static const int              NEW = 232;
			static const int             NEXT = 233;
			static const int              NOT = 234;
			static const int          NOTHING = 235;
			static const int   NOTINHERITABLE = 236;
			static const int   NOTOVERRIDABLE = 237;
			static const int           OBJECT = 238;
			static const int               OF = 239;

			static const int               ON = 240;
			static const int         OPERATOR = 241;
			static const int           OPTION = 242;
			static const int         OPTIONAL = 243;
			static const int               OR = 244;
			static const int           ORELSE = 245;
			static const int        OVERLOADS = 246;
			static const int      OVERRIDABLE = 247;
			static const int        OVERRIDES = 248;
			static const int       PARAMARRAY = 249;

			static const int          PARTIAL = 250;
			static const int          PRIVATE = 251;
			static const int         PROPERTY = 252;
			static const int        PROTECTED = 253;
			static const int           PUBLIC = 254;
			static const int       RAISEEVENT = 255;
			static const int         READONLY = 256;
			static const int            REDIM = 257;
			static const int    REMOVEHANDLER = 258;
			static const int           RESUME = 259;

			static const int           RETURN = 260;
			static const int            SBYTE = 261;
			static const int           SELECT = 262;
			static const int              SET = 263;
			static const int          SHADOWS = 264;
			static const int           SHARED = 265;
			static const int            SHORT = 266;
			static const int           SINGLE = 267;
			static const int           STATIC = 268;
			static const int             STEP = 269;

			static const int             STOP = 270;
			static const int           STRING = 271;
			static const int        STRUCTURE = 272;
			static const int              SUB = 273;
			static const int         SYNCLOCK = 274;
			static const int             THEN = 275;
			static const int            THROW = 276;
			static const int               TO = 277;
			static const int             TRUE = 278;
			static const int              TRY = 279;

			static const int          TRYCAST = 280;
			static const int           TYPEOF = 281;
			static const int         UINTEGER = 282;
			static const int            ULONG = 283;
			static const int           USHORT = 284;
			static const int            USING = 285;
			static const int          VARIANT = 286;
			static const int             WEND = 287;
			static const int             WHEN = 288;
			static const int            WHILE = 289;

			static const int         WIDENING = 290;
			static const int             WITH = 291;
			static const int       WITHEVENTS = 292;
			static const int        WRITEONLY = 293;
			static const int              XOR = 294;

			VisualBasicLex(std::tstring &ulc_fpath)
				 : uls::crux::UlsLex(ulc_fpath) {}
		};
	}
}
